# jinja.dart

#### Jinja 2 server-side template engine for Dart 2. Variables, expressions, control structures and template inheritance. Try to make your own web apps with Jinja 2 templates in Dart 2.

**Draft**

All variables passed to the template and literals used in the template are **dart objects** with their own fields and methods.

## To Do
- Docs
- Informative error handling
- Package tests
- Add missing filters and tests
- Loaders
  - PackageLoader
  - FunctionLoader
  - PrefixLoader
  - ChoiceLoader
- Whitespace Control
- Escaping
- Line Statements
- Statements
  - For
    - Recursive
  - Macro
  - Call
  - Filter
  - Set
  - Template Inheritance
    - Include
    - Import
- Expressions
  - *... if ... else ...* condition expression
  - *in*
  - *is* tests
  - *~* concat

## Done
- Loaders
  - FileSystemLoader
  - MapLoader (DictLoader)
- Variables
- Filters
  - abs
  - attr
  - default
  - join
  - list
  - lower
  - sublist
- Tests
  - defined
  - divisibleby
  - in
- Comments
- Statements
  - For
  - If
  - Template Inheritance
    - Extends
    - Block
      - Super
- Expressions
  - Literals
  - Math
  - Comparisons
  - Logic
  - *|* filters
  - *()* call callable
  - *.*/*[]* object attribute (*.* for field, *[]* for map)
